/*
 * Copyright (C) 2009 Sakari Poussa
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2.
 */

#include <QList>
#include <QVariant>
#include <QStringList>

#include "data.h"

class TreeItem
{

 public:
  enum Type { TypeRoot, TypeScore, TypeDate };

  TreeItem();
  TreeItem(const QString &str);
  TreeItem(Score *score);
  ~TreeItem();

#if 1
  void appendChild(TreeItem *item);
  int childCount() const;
  int columnCount() const;
  TreeItem *child(int row);
  QVariant data(int column) const;
  int row() const;
#endif

  Type type;
  QString str;
  Score *score;

  QList<TreeItem *> children;

  TreeItem *parent;

};
